//=============================================================================
//=============================================================================

#ifndef _INC_XC_ENGINE
#define _INC_XC_ENGINE


#define XC_CORE_API DLL_IMPORT

#ifndef __LINUX_X86__
	#define CORE_API DLL_IMPORT
	#define XC_ENGINE_API DLL_EXPORT
	#include <windows.h>
	#include <shlobj.h>
#else
	//If we don't disable this, v436 std (some builds) won't be able to run this mod
	#define DO_GUARD 0
	#include <unistd.h>	
#endif


//Disablers, used for debugging and fast builds
//#define DISABLE_COLLISION
//#define DISABLE_PROPERTIES
//#define DISABLE_ADDONS
//#define DISABLE_SCRIPT
//#define DISABLE_STATICS
//#define KILL_ENGINE

#ifdef KILL_ENGINE
	#define DISABLE_SCRIPT
	#define DISABLE_ADDONS
#endif

//Engine includes
#include "Engine.h"

#ifndef __LINUX_X86__
	#include "..\..\Window\inc\Window.h"
#endif


//class UXC_GameEngine;
#ifndef DISABLE_ADDONS
	class FXC_TravelManager;
	class FXC_TimeManager;
#endif
#ifndef DISABLE_COLLISION
	class FCollisionCacus;
	class FNodeGrid3;
#endif

//Script
#define warnf GWarn->Logf
#define debugf GLog->Logf
#define NAME_XC_Engine (EName)XC_ENGINE_XC_Engine.GetIndex()

//XC_Core
#include "UnXC_Math.h"

//Classes here
#include "UnXC_Game.h"		// Game Engine edited
#include "XC_Inlines.h"

#ifdef __LINUX_X86__
	#undef CPP_PROPERTY
	#define CPP_PROPERTY(name) \
		EC_CppProperty, (BYTE*)&((ThisClass*)1)->name - (BYTE*)1
#endif

#endif
