// Search mask for Botpack.Bot.SetOrders()
// 07, XX, XX, 77, 00, YY, YY, YY, YY, 2A, 16
// 0xXXXX = jump destination
// 0xYYYYYYYY = reference to P

//82 , 72 , 2E , 9 bytes , 2A , 16 , 18 , 2 bytes (unknown), 72 , 2E , 9 bytes , 2A , 16, 16

//Next to (P != none) from the For iterator
//We need this line
// if ( (P.PlayerReplicationInfo != none) && (P.PlayerReplicationInfo.Team == PlayerReplicationInfo.Team) )
//Instead of
// if ( P.bIsPlayer && (P.PlayerReplicationInfo.Team == PlayerReplicationInfo.Team) )


void UXC_GameEngine::ReplaceSetOrdersFunc( UBOOL bSet)
{
	guard(UXC_GameEngine::ReplaceSetOrdersFunc);
	if ( (bSetOrders && bSet) || (!bSetOrders && !bSet) )
		return;
	UClass* Bot = NULL;
	for( TObjectIterator<UClass> It; It; ++It )
		if( It->GetOuter() && (appStricmp( It->GetOuter()->GetName(), TEXT("Botpack") ) == 0) && (appStricmp( It->GetName(), TEXT("Bot") ) == 0) )
		{
			Bot = *It;
			break;
		}
	if ( !Bot )
	{
		bSetOrders = 0;
		return;
	}

	UFunction* SetOrders = FindBaseFunction( Bot, TEXT("SetOrders") );
//	if ( !SetOrders ) //ASSUMED
//		return;

	if ( OldSetOrders.IsCleared() && (!bSet || !OldSetOrders.Setup( &SetOrders->Script )) )
		return;

	if ( !bSet )
	{
		OldSetOrders.Restore( &SetOrders->Script);
		OldSetOrders.Clear();
		if ( bEnableDebugLogs )
			debugf( NAME_XC_Engine, TEXT("Reverting Bot.SetOrders hook") );
		bSetOrders = 0;
		return;
	}

	//Initialize remaining vars
	INT Found = 0;
	UProperty* P = FindScriptVariable( SetOrders, TEXT("P"), &Found);
	UProperty* PlayerReplicationInfo = FindScriptVariable( APawn::StaticClass(), TEXT("PlayerReplicationInfo"), &Found);
	UProperty* Team = FindScriptVariable( APlayerReplicationInfo::StaticClass(), TEXT("Team"), &Found);
	check( Found == 3 );

	//Find the line we have to replace
	INT LoopCount = 0; //v436 code is at location 786, but we're keeping this for version compatibility
	BYTE* Block = &SetOrders->Script( 750 );
	while ( true )
	{
		if ( (*Block == 0x07) && (*(Block+3) == 0x77) && (*(Block+4) == 0x00)
		 && (*(Block+9) == 0x2A) && (*(Block+10) == 0x16) && (*(Block+11) == 0x07) )
			break;
		if ( LoopCount++ >= 200 ) //We didn't find the code
		{
			debugf( NAME_XC_Engine, TEXT("Bot's bSetOrders: block not found"));
			return;
		}
		Block++;
	}
	_WORD JumpBackOffset = *(	(_WORD*)	(Block+12)	); //798 in v436 UT > P=P.NextPawn block
	_WORD JumpForwardOffset = (_WORD) SetOrders->Script.Num();
	_WORD JumpIfTrueOffset = (_WORD) (750 + LoopCount + 75);
	check( *(Block + 75) == 0x0F ); //Check that B = Bot(P) is there...

	Block += 11; //Go past (P != none), replace the following IF with a jump.
	JumpTo( Block, JumpForwardOffset); Block+=3; //Jump to byte after end of function
	for ( LoopCount=0 ; LoopCount < 61 ; LoopCount++ )
		*Block++ = 0x0B;	//Clear out the whole line + return false with EX_Nothing
	
	SetOrders->Script.Add(71); //Reallocation occurred, we need to reset Block
	Block = &SetOrders->Script(0) + JumpForwardOffset;
	JumpToIfNot( Block, JumpBackOffset); Block += 3; // (3)
	*Block++ = 0x82; // && (4)
	*Block++ = 0x77; // != (5)
	_obj_SingleContext( Block, 0, P); Block+=9; // (14)
	ParseInstanceVariable( Block, PlayerReplicationInfo); Block+=5; // (19)
	*Block++ = 0x2A; // EX_None (20)
	*Block++ = 0x16; // EX_EndFunctionParams (21)
	SkipAhead( Block, 42); Block += 3;	// (24)
	*Block++ = 0x9A; // == (25)
	*Block++ = 0x3A; // EX_ByteToInt (26)
	*Block++ = 0x19; // EX_Context (27)
	_obj_SingleContext( Block, 0, P); Block+=9; // (36)
	ParseInstanceVariable( Block, PlayerReplicationInfo); Block+=5; // (41)
	*Block++ = 0x05; // context stuff
	*Block++ = 0x00; // context stuff
	*Block++ = 0x01; // context stuff (44)
	ParseInstanceVariable( Block, Team); Block+=5; // (49)
	*Block++ = 0x3A; // EX_ByteToInt (50)
	*Block++ = 0x19; // EX_Context (51)
	ParseInstanceVariable( Block, PlayerReplicationInfo); Block+=5; // (56)
	*Block++ = 0x05; // context stuff
	*Block++ = 0x00; // context stuff
	*Block++ = 0x01; // context stuff (59) BYTE CONTEXTS USE (0x01) IN THAT BYTE!!!
	ParseInstanceVariable( Block, Team); Block+=5; // (64)
	*Block++ = 0x16; // EX_EndFunctionParams (65)
	*Block++ = 0x16; // EX_EndFunctionParams (66)
	JumpTo( Block, JumpIfTrueOffset); Block+=3; // (69)
	AddReturn( Block); // (71) - THIS IS A SAFETY RETURN

	bSetOrders = 1;
	if ( bEnableDebugLogs )
		debugf( NAME_XC_Engine, TEXT("Bot's bSetOrders hook success"));
	unguard;
}